import 'package:gui_app/const/colors.dart';
import 'package:flutter/material.dart';
import 'package:syncfusion_flutter_core/theme.dart';
import 'package:syncfusion_flutter_sliders/sliders.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:gui_app/const/dimens.dart';
import 'package:gui_app/provider.dart';

class TouchSlider extends ConsumerStatefulWidget {
  final double width;
  final double height;
  const TouchSlider(
      {Key? key, this.width = double.infinity, this.height = double.infinity})
      : super(key: key);
  @override
  ConsumerState<TouchSlider> createState() {
    return _SliderState();
  }
}

const double _min = 0;
const double _max = 100;

class _SliderState extends ConsumerState<TouchSlider> {
  @override
  Widget build(BuildContext context) {
    final Size containerSize = MediaQuery.of(context).size;
    return SizedBox(
      width: widget.width,
      height: widget.height,
      child: SfSliderTheme(
        data: SfSliderThemeData(
          activeLabelStyle: TextStyle(
              color: textColor,
              fontSize: containerSize.width * sliderLabelFontSizeRatio),
          inactiveLabelStyle: TextStyle(
              color: textColor,
              fontSize: containerSize.width * sliderLabelFontSizeRatio),
        ),
        child: SfSlider(
          min: _min,
          max: _max,
          value: ref.watch(sliderProvider.state).state,
          interval: 20,
          showLabels: true,
          showTicks: true,
          enableTooltip: true,
          activeColor: sliderColor,
          onChanged: (dynamic newValue) {
            ref.read(sliderProvider.notifier).state = newValue.toInt();
          },
        ),
      ),
    );
  }
}
